Bug 618524 - Document how to enable padlock engine for openssl
Document how to enable padlock engine for openssl
Status: CLOSED NEXTRELEASE
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: doc-Security_Guide (Show other bugs)
6.0
All Linux
low Severity high
: rc
: ---
Assigned To: Scott Radvan
ecs-bugs
: Documentation
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2010-07-27 03:43 EDT by Miroslav Vadkerti
Modified: 2015-04-06 23:19 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2010-07-29 18:33:52 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Miroslav Vadkerti 2010-07-27 03:43:58 EDT
Description of problem:
The possibility of using HW crypto engine coming with VIA C7 CPUs should be documented. This should be documented maybe also in Installation guide (not sure). 

See bug 563574
Comment 1 Miroslav Vadkerti 2010-07-27 03:44:50 EDT
Tomas, any idea where this documentation should go? Which guide, or should be it also in man pages?
Comment 4 Scott Radvan 2010-07-28 17:25:29 EDT
Need specific details in order to add this. I don't have this information. Have marked NEEDINFO.
Comment 5 Miroslav Vadkerti 2010-07-29 05:17:12 EDT
After discussion this should go to security guide
Comment 6 Miroslav Vadkerti 2010-07-29 05:52:30 EDT
To enable padlock engine in openssl edit /etc/pki/tls/openssl.cnf and add

On the begging of the config file
  openssl_conf = openssl_init

Append on the end:
  [openssl_init]
  engines = openssl_engines
  [openssl_engines]
  padlock = padlock_engine
  [padlock_engine]
  default_algorithms = ALL
  dynamic_path = /usr/lib/openssl/engines/libpadlock.so
  init = 1

Note for 64but systems use:
dynamic_path = /usr/lib64/openssl/engines/libpadlock.so

To check if module enabled run (is should be listed)
# openssl engine -c -tt

To test openssl with padlock use:
# openssl speed aes-128-cbc

'openssl speed' without the hardware engine shows roughly 11MB/s throughput. 
With padlock turned on, it jumps to 98MB/s-1.9GB/s depending on block size. 
(yes, really, 1.9GB/s!)

To test openssh speed you can run a command like:
dd if=/dev/zero count=100 bs=1M | ssh -c aes128-cbc localhost "cat >/dev/null
Actual results:

openssh without padlock engine shows throughput roughly 5MB/s, with the padlock engine it should be significantly improoved

More information on VIA padlock engine is here:
http://www.logix.cz/michal/devel/padlock/

Scott is this info enough for you?
Jan, any other suggestions?
Comment 7 Scott Radvan 2010-07-29 18:33:52 EDT
Miroslav, thank you for that information, it's appreciated. I've added details on this to the Security Guide, and changes will appear on next publish.

Note You need to log in before you can comment on or make changes to this bug.